<?php
/**
 * Project: sURI :: Secure URI<br>
 * File:    sURI/hash_generator.php
 *
 * sURI 해시 생성기
 *
 * sURI에서 사용하는 해시 키/값을 생성한다.
 *
 * @category   HTML
 * @package    sURI
 * @subpackage sURI_hash
 * @author     JoungKyun.Kim <http://oops.org>
 * @copyright  (c) 2014 JoungKyun.Kim
 * @license    BSD
 * @version    $Id: hash_generate.php 59 2014-01-25 10:01:51Z oops $
 * @link       http://pear.oops.org/package/sURI
 * @since      File available since Release 0.1
 * @filesource
 */

$unit = array ('I', 'A', 'R', 'a', 'S', 'F', 'N');
$unitno = array (8, 8, 9, 9, 9, 9, 8);
$parameter = array (
	'A', 'B', 'C', 'D', 'E', 'F', 'H', 'I', 'J', 'K', 'L', 'M',
	'N', 'O', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	'n', 'o', 'p', 'q', 'l', 's', 't', 'u', 'v', 'w', 'x', 'y', 'Z',
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'
);

srand((float)microtime() * 1000000);
shuffle($parameter);

foreach ( $unit as $key => $v ) {
	for ( $i=0; $i<$unitno[$key]; $i++ )
		$value->$v .= '\'' . array_shift ($parameter) . '\',';

	$value->$v = preg_replace ('/,$/', '', $value->$v);
}

$buf = <<<EOF
<?php
/**
 * Project: sURI :: Secure URI<br>
 * File:    sURI/hash.php
 *
 * URI 매배변수 해시 키
 *
 * 해시 값은 반드시 [a-zA-Z0-9] 범위여야 하며, 무작위 순서의 값을
 * 권고 햐며 아래의 hash_generator.php를 이용하여 꼭 재생성 해서
 * 사용하여야 한다.
 *
 * 이 파일은 sURI/hash_generator.php 로 재생성 할 수 있다.
 *
 * <code>
 * shell# php hash_generator.php > hash.php
 * </code>
 *
 * @category   HTML
 * @package    sURI
 * @subpackage sURI_hash
 * @author     JoungKyun.Kim <http://oops.org>
 * @copyright  (c) 2014 JoungKyun.Kim
 * @license    BSD
 * @version    \$Id: hash.php 38 2012-09-09 12:34:43Z oops \$
 * @link       http://pear.oops.org/package/sURI
 * @since      File available since Release 0.1
 * @filesource
 */
global \$___hashunit;
global \$hashno;
\$hashno = 0;
#
## default hash
##
\$___hashunit[\$hashno]['I'] = array ({$value->I});
\$___hashunit[\$hashno]['A'] = array ({$value->A});
\$___hashunit[\$hashno]['R'] = array ({$value->R});
\$___hashunit[\$hashno]['a'] = array ({$value->a});
\$___hashunit[\$hashno]['S'] = array ({$value->S});
\$___hashunit[\$hashno]['F'] = array ({$value->F});
\$___hashunit[\$hashno++]['N'] = array ({$value->N});

#
# next hash
#
/*
\$___hashunit[\$hashno]['I'] = array ('A', 'B', 'C', 'D', 'E', 'F', 'H', 'I');
\$___hashunit[\$hashno]['A'] = array ('J', 'K', 'L', 'M', 'N', 'O', 'Q', 'R');
\$___hashunit[\$hashno]['R'] = array ('S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a');
\$___hashunit[\$hashno]['a'] = array ('b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j');
\$___hashunit[\$hashno]['S'] = array ('k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's');
\$___hashunit[\$hashno]['F'] = array ('t', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1');
\$___hashunit[\$hashno++]['N'] = array ('2', '3', '4', '5', '6', '7', '8', '9');
*/
?>
EOF;

echo $buf;
?>
